//----------------------------------------------------------------------------------
// File:        nvpr\Tiger3DES/tiger_style.h
// SDK Version: v2.11 
// Email:       gameworks@nvidia.com
// Site:        http://developer.nvidia.com/
//
// Copyright (c) 2014-2015, NVIDIA CORPORATION. All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//  * Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
//  * Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//  * Neither the name of NVIDIA CORPORATION nor the names of its
//    contributors may be used to endorse or promote products derived
//    from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
// EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
// OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//----------------------------------------------------------------------------------
/* style information for classic PostScript tiger paths */
/* 1st=0xRRGGBB fill color, 2nd=0xRRGGBB stroke color, 3rd=stroke width (0 means fill only, negative means only stroke, positive means fill+stroke) */
{0xffffff, 0x000000, 0.172f},
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 0.172f },
{ 0xffffff, 0x000000, 1 },
{ 0xcc7226, 0x000000, 1 },
{ 0xcc7226, 0x0, 0 },
{ 0xe87f3a, 0x0, 0 },
{ 0xea8c4d, 0x0, 0 },
{ 0xec9961, 0x0, 0 },
{ 0xeea575, 0x0, 0 },
{ 0xf1b288, 0x0, 0 },
{ 0xf3bf9c, 0x0, 0 },
{ 0xf5ccb0, 0x0, 0 },
{ 0xf8d8c4, 0x0, 0 },
{ 0xfae5d7, 0x0, 0 },
{ 0xfcf2eb, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xe5668c, 0x0, 0 },
{ 0xb23259, 0x0, 0 },
{ 0xa5264c, 0x0, 0 },
{ 0xff727f, 0x000000, 1 },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xcc3f4c, 0x0, 0 },
{ 0x0, 0xa51926, -2 },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0x0, 0xa5264c, -2 },
{ 0x0, 0xa5264c, -2 },
{ 0xffffcc, 0x000000, 0.5f },
{ 0x0, 0xa5264c, -2 },
{ 0x0, 0xa5264c, -2 },
{ 0xb2b2b2, 0x0, 0 },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0x000000, 0x0, 0 },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xffffcc, 0x000000, 0.5f },
{ 0xe5e5b2, 0x0, 0 },
{ 0xe5e5b2, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xea8e51, 0x0, 0 },
{ 0xefaa7c, 0x0, 0 },
{ 0xf4c6a8, 0x0, 0 },
{ 0xf9e2d3, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x99cc32, 0x0, 0 },
{ 0x659900, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0xeb955c, 0x0, 0 },
{ 0xf2b892, 0x0, 0 },
{ 0xf8dcc8, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x99cc32, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x323232, 0x0, 0 },
{ 0x666666, 0x0, 0 },
{ 0x999999, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0x992600, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0xcc7226, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x0, 0x4c0000, -2 },
{ 0x0, 0x4c0000, -2 },
{ 0x0, 0x4c0000, -2 },
{ 0x0, 0x4c0000, -2 },
{ 0x000000, 0x0, 0 },
{ 0x4c0000, 0x0, 0 },
{ 0x99cc32, 0x0, 0 },
{ 0x659900, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xe59999, 0x0, 0 },
{ 0xb26565, 0x0, 0 },
{ 0x992600, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0x992600, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0xffffff, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x992600, 0x0, 0 },
{ 0x992600, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xcccccc, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xffffff, 0x000000, 0.1f },
{ 0x000000, 0x0, 0 },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0xffffff, 0x000000, 0.1f },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0x000000, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0xcccccc, 0x0, 0 },
{ 0x0, 0x000000, -1.0f },
{ 0x0, 0x000000, -1.0f },
{ 0x0, 0x000000, -1.0f },
{ 0x0, 0x000000, -1.0f },
